CSIT-806 Container Orchestration in CSIT - Low Level Design
[csit.git] / bootstrap-hc2vpp-integration-odl.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 export DEBIAN_FRONTEND=noninteractive
21 sudo apt-get -y update
22 sudo apt-get -y install libpython2.7-dev python-virtualenv
23
24 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
25 VIRL_SERVER=""
26
27 VIRL_USERNAME=jenkins-in
28 VIRL_PKEY=priv_key
29 VIRL_SERVER_STATUS_FILE="status"
30 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
31
32 ARCHIVE_ARTIFACTS=(log.html output.xml report.html honeycomb.log)
33
34 STREAM=$1
35 OS=$2
36 ODL=$3
37
38 if [ "${OS}" == "ubuntu1604" ]; then
39     VIRL_TOPOLOGY=double-ring-nested.xenial
40     VIRL_RELEASE=csit-ubuntu-16.04.1_2017-02-23_1.8
41 elif [ "${OS}" == "centos7" ]; then
42     VIRL_TOPOLOGY=double-ring-nested.centos7
43     VIRL_RELEASE=csit-centos-7.3-1611_2017-02-23_1.4
44 fi
45
46 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
47
48 function ssh_do() {
49     echo
50     echo "### "  ssh $@
51     ssh ${SSH_OPTIONS} $@
52 }
53
54 rm -f ${VIRL_PKEY}
55 cat > ${VIRL_PKEY} <<EOF
56 -----BEGIN RSA PRIVATE KEY-----
57 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
58 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
59 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
60 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
61 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
62 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
63 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
64 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
65 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
66 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
67 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
68 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
69 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
70 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
71 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
72 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
73 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
74 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
75 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
76 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
77 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
78 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
79 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
80 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
81 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
82 -----END RSA PRIVATE KEY-----
83 EOF
84 chmod 600 ${VIRL_PKEY}
85
86 #
87 # Pick a random host from the array of VIRL servers, and attempt
88 # to reach it and verify it's status.
89 #
90 # The server must be reachable, and have a "status" file with
91 # the content "PRODUCTION", to be selected.
92 #
93 # If the server is not reachable, or does not have the correct
94 # status, remove it from the array and start again.
95 #
96 # Abort if there are no more servers left in the array.
97 #
98 while [[ ! "$VIRL_SERVER" ]]
99 do
100     num_hosts=${#VIRL_SERVERS[@]}
101     if [ $num_hosts == 0 ]
102     then
103         echo "No more VIRL candidate hosts available, failing."
104         exit 127
105     fi
106     element=$[ $RANDOM % $num_hosts ]
107     virl_server_candidate=${VIRL_SERVERS[$element]}
108     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
109     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
110     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
111     then
112         # Candidate is in good status. Select this server.
113         VIRL_SERVER="$virl_server_candidate"
114     else
115         # Candidate is in bad status. Remove from array.
116         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
117     fi
118 done
119
120 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
121
122 # Download VPP and HC packages from the current branch
123 echo Downloading packages...
124 bash ${SCRIPT_DIR}/resources/tools/scripts/download_hc_pkgs.sh ${STREAM} ${OS}
125
126 if [ "${OS}" == "centos7" ]; then
127     VPP_PKGS=(*.rpm)
128 else
129     VPP_PKGS=(*.deb)
130 fi
131 echo ${VPP_PKGS[@]}
132 VIRL_DIR_LOC="/tmp"
133 VPP_PKGS_FULL=(${VPP_PKGS[@]})
134
135 # Prepend directory location at remote host to package file list
136 for index in "${!VPP_PKGS_FULL[@]}"; do
137     VPP_PKGS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_FULL[${index}]}
138 done
139
140 echo "Updated file names: " ${VPP_PKGS_FULL[@]}
141
142 cat ${VIRL_PKEY}
143
144 # Copy the files to VIRL hosts
145 DONE=""
146 for index in "${!VIRL_SERVER[@]}"; do
147     # Do not copy files in case they have already been copied to the VIRL host
148     [[ "${DONE[@]}" =~ "${VIRL_SERVER[${index}]}" ]] && copy=0 || copy=1
149
150     if [ "${copy}" -eq "0" ]; then
151         echo "files have already been copied to the VIRL host ${VIRL_SERVER[${index}]}"
152     else
153         if [ "${OS}" == "centos7" ]; then
154             scp ${SSH_OPTIONS} *.rpm \
155                 ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
156         else
157             scp ${SSH_OPTIONS} *.deb \
158                 ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
159         fi
160          result=$?
161         if [ "${result}" -ne "0" ]; then
162             echo "Failed to copy files to VIRL host ${VIRL_SERVER[${index}]}"
163             echo ${result}
164             exit ${result}
165         else
166             echo "files successfully copied to the VIRL host ${VIRL_SERVER[${index}]}"
167         fi
168         DONE+=(${VIRL_SERVER[${index}]})
169     fi
170 done
171
172 # Start a simulation on VIRL server
173 echo "Starting simulation on VIRL server"
174
175 function stop_virl_simulation {
176     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
177         "stop-testcase ${VIRL_SID}"
178 }
179
180 VIRL_SID=$(ssh ${SSH_OPTIONS} \
181     ${VIRL_USERNAME}@${VIRL_SERVER} \
182     "start-testcase -c ${VIRL_TOPOLOGY} -r ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
183 retval=$?
184 if [ "${retval}" -ne "0" ]; then
185     echo "VIRL simulation start failed"
186     exit ${retval}
187 fi
188
189 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
190     echo "No VIRL session ID reported."
191     exit 127
192 fi
193
194 # Upon script exit, cleanup the simulation execution
195 trap stop_virl_simulation EXIT
196 echo ${VIRL_SID}
197
198 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
199
200 # Download the topology file from virl session
201 scp ${SSH_OPTIONS} \
202     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
203     topologies/enabled/topology.yaml
204
205 retval=$?
206 if [ "${retval}" -ne "0" ]; then
207     echo "Failed to copy topology file from VIRL simulation"
208     exit ${retval}
209 fi
210
211 virtualenv --system-site-packages env
212 . env/bin/activate
213
214 echo pip install
215 pip install -r ${SCRIPT_DIR}/requirements.txt
216
217 pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
218           -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
219           -d ${SCRIPT_DIR}/topologies/enabled/topology.yaml \
220           -vvv
221
222 if [ "$?" -ne "0" ]; then
223     echo "Topology schema validation failed."
224     echo "However, the tests will start."
225 fi
226
227 PYTHONPATH=`pwd` pybot -L TRACE -W 136\
228     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology.yaml \
229     --suite "tests.vpp.func" \
230     --include HC_FUNC \
231     --exclude HC_REST_ONLY \
232     --noncritical EXPECTED_FAILING \
233     --variable HC_ODL:${ODL} \
234     tests/
235
236 RETURN_STATUS=$?
237
238 # Get Honeycomb log file from virl host
239 scp ${SSH_OPTIONS} \
240     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/honeycomb.log . || true
241
242 # Archive artifacts
243 mkdir archive
244 for i in ${ARCHIVE_ARTIFACTS[@]}; do
245     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
246 done
247
248 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.